package org.dspace.webservice;

/**
 * Interface to web service
 *
 * @author Nordija A/S (www.nordija.com) for Center of Knowledge Technology (www.cvt.dk)
 */
public interface DSpace {

  /**
   * Update a person
   *
   * @param username           user to login with
   * @param password           password for user to login with
   * @param email              email of the person to update. If email does not exist a new {@link org.dspace.eperson.EPerson} is created
   * @param fields             array of person properties that needs to be updated
   * @param includedInGroups   groups to be included in. Groups that do not exist are created
   * @param excludedFromGroups groups to be excluded from. Groups that do not exist are ignored
   */
  void updateEPerson(String username, String password, String email, EPersonField[] fields, EPersonGroup[] includedInGroups, EPersonGroup[] excludedFromGroups);

  /**
   * Update a collection of persons.
   *
   * @param username           user to login with
   * @param password           password for user to login with
   * @param epersonUpdate      person to update.
   *
   * @see #updateEPerson(String, String, String, EPersonField[], EPersonGroup[], EPersonGroup[])
   */
  void updateEPersons(String username, String password, EPersonUpdate[] epersonUpdate);
}
