package org.dspace.webservice;

/**
 * Class representing an update to a eperson {@link org.dspace.eperson.EPerson}.
 *
 * @author Nordija A/S (www.nordija.com) for Center of Knowledge Technology (www.cvt.dk)
 */
public class EPersonUpdate {
  private String email;
  private EPersonField[] fields;
  private EPersonGroup[] includedInGroups;
  private EPersonGroup[] excludedFromGroups;

  public EPersonUpdate() {
  }

  public EPersonUpdate(String email, EPersonField[] fields, EPersonGroup[] includedInGroups, EPersonGroup[] excludedFromGroups) {
    this.email = email;
    this.fields = fields;
    this.includedInGroups = includedInGroups;
    this.excludedFromGroups = excludedFromGroups;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public void setFields(EPersonField[] fields) {
    this.fields = fields;
  }

  public void setIncludedInGroups(EPersonGroup[] includedInGroups) {
    this.includedInGroups = includedInGroups;
  }

  public void setExcludedFromGroups(EPersonGroup[] excludedFromGroups) {
    this.excludedFromGroups = excludedFromGroups;
  }

  public String getEmail() {
    return email;
  }

  public EPersonField[] getFields() {
    return fields;
  }

  public EPersonGroup[] getIncludedInGroups() {
    return includedInGroups;
  }

  public EPersonGroup[] getExcludedFromGroups() {
    return excludedFromGroups;
  }
}
