package org.dspace.webservice.client;

import org.apache.axis.AxisFault;
import org.dspace.webservice.generated.*;

/**
 * Example client to web service
 *
 * Note: for the client to be successfull, users and groups referenced by the client has to be created beforehand    
 *
 * @author Nordija A/S (www.nordija.com) for Center of Knowledge Technology (www.cvt.dk)
 */
public class DSpaceClient
{
  private static final String USERNAME = "admin@mycompany.com";
  private static final String PASSWORD = "dspace";
  private static final String DEFAULT_ENDPOINT = "http://localhost:8080/dspace/services/DSpace";
  private static final String SERVICE_NAME = "DSpace";

  private static final String USER_EMAIL = "johndoe@mycompany.com";
  private static final String USER_LASTNAME = "Doe";
  private static final String USER_GROUP_INCLUDE_1 = "group1";
  private static final String USER_GROUP_INCLUDE_2 = "group2";
  private static final String USER_GROUP_EXCLUDE_3 = "group3";

  public static final void main(String[] args)
  {
    final String endPoint = args.length == 1 ? args[0] : DEFAULT_ENDPOINT;

    try
    {
      final String email = USER_EMAIL;

      final EPersonField[] fields = new EPersonField[1];
      fields[0] = new EPersonField();
      fields[0].setName("lastname");
      fields[0].setValue(USER_LASTNAME);

      final EPersonGroup[] includedInGroups = new EPersonGroup[2];
      includedInGroups[0] = new EPersonGroup();
      includedInGroups[0].setName(USER_GROUP_INCLUDE_1);
      includedInGroups[1] = new EPersonGroup();
      includedInGroups[1].setName(USER_GROUP_INCLUDE_2);

      final EPersonGroup[] excludedFromGroups = new EPersonGroup[1];
      excludedFromGroups[0] = new EPersonGroup();
      excludedFromGroups[0].setName(USER_GROUP_EXCLUDE_3);

      final DSpaceServiceLocator service = new DSpaceServiceLocator();
      service.setDSpaceEndpointAddress(endPoint);
      service.setDSpaceWSDDServiceName(SERVICE_NAME);

      final DSpace dspace = service.getDSpace();

//      dspace.updateEPerson(USERNAME, PASSWORD, email, fields, includedInGroups, excludedFromGroups);

      final EPersonUpdate ePersonUpdate = new EPersonUpdate();
      ePersonUpdate.setEmail(email);
      ePersonUpdate.setFields(fields);
      ePersonUpdate.setIncludedInGroups(includedInGroups);
      ePersonUpdate.setExcludedFromGroups(excludedFromGroups);

      dspace.updateEPersons(USERNAME, PASSWORD, new EPersonUpdate[] { ePersonUpdate });

    } catch (AxisFault e)
    {
      Utils.printAxisFault(e, System.err);
    } catch (Exception e)
    {
      System.err.println("Ups, got exception");
      e.printStackTrace();
    }
  }

}
