package org.dspace.webservice.client;

import org.apache.axis.AxisFault;
import org.w3c.dom.Element;

import javax.xml.namespace.QName;
import java.io.PrintStream;

/**
 * Web service utilities
 *
 * @author Nordija A/S (www.nordija.com) for Center of Knowledge Technology (www.cvt.dk)
 */
public class Utils
{
  public static void printAxisFault(AxisFault x, PrintStream o)
  {
    // tested with Axis 1.1 & Axis 1.2 alpha
    if (x.getFaultCode().equals(new QName("http://xml.apache.org/axis/", "HTTP")))
    {
      Element e =
          x.lookupFaultDetail(new QName("http://xml.apache.org/axis/", "HttpErrorCode"));
      if (null != e)
      {
        e.normalize();
        String httpErrorCode = e.getFirstChild().getNodeValue().trim();
        if (httpErrorCode.equals("407"))
          o.println("Proxy password incorrect");
        else if (httpErrorCode.equals("502") || httpErrorCode.equals("504"))
          o.println("Proxy cannot find the server");
        else if (httpErrorCode.equals("500"))
          o.println("Proxy or server unavailable");
        else if (httpErrorCode.equals("404"))
          o.println("No Web service (404 File Not Found)");
        else
          o.println(x.getFaultString());
      }
      else
        o.println("Network error: " + x.getFaultString());
    }
    else if (x.getFaultCode().equals(new QName("http://schemas.xmlsoap.org/soap/envelope/",
        "Server.userException")))
    {
      o.println("Most likely a net error: " + x.getFaultString());
      o.println(x.dumpToString());
    }
    else
    {
      o.println("SOAP Fault: " + x.getFaultCode() + ", "
          + x.getFaultString());
    }
  }
}
